"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Range = exports.DFSOperation = void 0;
var DFSOperation;
(function (DFSOperation) {
    DFSOperation[DFSOperation["VISIT"] = 0] = "VISIT";
    DFSOperation[DFSOperation["PROCESS"] = 1] = "PROCESS";
})(DFSOperation = exports.DFSOperation || (exports.DFSOperation = {}));
class Range {
    constructor(low, high, includeLow = true, includeHigh = true) {
        this.low = low;
        this.high = high;
        this.includeLow = includeLow;
        this.includeHigh = includeHigh;
    }
    // Determine whether a key is within the range
    isInRange(key, comparator) {
        const lowCheck = this.includeLow ? comparator(key, this.low) >= 0 : comparator(key, this.low) > 0;
        const highCheck = this.includeHigh ? comparator(key, this.high) <= 0 : comparator(key, this.high) < 0;
        return lowCheck && highCheck;
    }
}
exports.Range = Range;
